﻿using FarPoint.Win.Chart;
using FarPoint.Win.Spread;
using GrapeCity.Spreadsheet;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Windows.Forms;
using System.Xml;

namespace Spread_Win
{
    public partial class Form1 : Form
    {
        [Serializable()]
        public class GetEstimation : FarPoint.CalcEngine.FunctionInfo
        {


            public GetEstimation()
            {
                
            }

            /// <summary>
            /// Override method for defining name for custom formula 
            /// </summary>
            public override string Name { get { return "GetEstimation"; } }

            /// <summary>
            /// Specifies minimum number of argument for the custom method
            /// </summary>
            public override int MinArgs { get { return 1; } }

            /// <summary>
            /// Specifies maximum number of argument for the custom method
            /// </summary>
            public override int MaxArgs { get { return 1; } }

            /// <summary>
            /// Evaluates the method based on argument list and returns result of object type
            /// </summary>
            /// <param name="args">argument list</param>
            /// <returns>returns object instance</returns>
            public override object Evaluate(object[] args)
            {
             
                return "1";

             
            }
        }

        public enum BCNWorksheetStatus
        {
            None = 0,
            Bid = 1,
            Contract = 2,
            Production = 3
        }
        public enum BCNPartOf
        {
            /// <summary>
            /// 
            /// </summary>
            System = 0,

            /// <summary>
            /// 
            /// </summary>
            Custom = 1,

            /// <summary>
            /// 
            /// </summary>
            Estimation = 2,

            /// <summary>
            /// 
            /// </summary>
            ATA = 3,

            /// <summary>
            /// 
            /// </summary>
            SystemCustom = 4,

            /// <summary>
            /// Personal/private objects 
            /// </summary>
            Personal = 5
        }
        private class SheetTagValue
        {
            /// <summary>
            /// Private variable to hold PartOf.
            /// </summary>
            private BCNPartOf partOf;

            /// <summary>
            /// Gets/Sets the NodeType.
            /// </summary>
            public BCNPartOf PartOf
            {
                get { return partOf; }
                set { partOf = value; }
            }

            /// <summary>
            /// Private variable to hold PartOf.
            /// </summary>
            private BCNWorksheetStatus estiamtionPhase;

            /// <summary>
            /// Gets/Sets the NodeType.
            /// </summary>
            public BCNWorksheetStatus EstiamtionPhase
            {
                get { return estiamtionPhase; }
                set { estiamtionPhase = value; }
            }

            /// <summary>
            /// Empty Constructor
            /// </summary>
            public SheetTagValue()
            {

            }

            /// <summary>
            /// Constructor
            /// </summary>
            /// <param name="partOf"><see cref="BCNPartOf"/> Part Of Value (System/Custom)</param>
            public SheetTagValue(BCNPartOf partOf)
            {
                this.partOf = partOf;
            }

            /// <summary>
            /// Constructor
            /// </summary>
            /// <param name="estiamtionPhase"><see cref="BCNWorksheetStatus"/> Estimation Phase Value</param>
            public SheetTagValue(BCNWorksheetStatus estiamtionPhase)
            {
                this.estiamtionPhase = estiamtionPhase;
            }

            /// <summary>
            /// Constructor
            /// </summary>
            /// <param name="partOf"><see cref="BCNPartOf"/>Part Of Value (System/Custom)</param>
            /// <param name="estiamtionPhase"><see cref="BCNWorksheetStatus"/>Estimation Phase Value</param>
            public SheetTagValue(BCNPartOf partOf, BCNWorksheetStatus estiamtionPhase)
            {
                this.partOf = partOf;
                this.estiamtionPhase = estiamtionPhase;
            }

            /// <summary>
            /// Private variable to hold memberEstimationId
            /// </summary>
            private Guid memberEstimationId;
            public Guid MemberEstimationId
            {
                get { return memberEstimationId; }
                set { memberEstimationId = value; }
            }

            /// <summary>
            /// discipline and disciplineNumber exists due to backwords compability, 
            /// removing one of thees will break Serialization/Deserialzation
            /// </summary>
            [NonSerialized]
            private byte discipline;

            /// <summary>
            /// discipline and disciplineNumber exists due to backwords compability, 
            /// removing one of thees will break Serialization/Deserialzation
            /// </summary>
            public byte Discipline
            {
                get { return discipline; }
                set { discipline = value; }
            }

            /// <summary>
            /// discipline and disciplineNumber exists due to backwords compability, 
            /// removing one of thees will break Serialization/Deserialzation
            /// </summary>
            private int disciplineNumber;

            /// <summary>
            /// discipline and disciplineNumber exists due to backwords compability, 
            /// removing one of thees will break Serialization/Deserialzation
            /// </summary>
            public int DisciplineNumber
            {
                get { return disciplineNumber; }
                set { disciplineNumber = value; }
            }
        }
        public Form1()
        {
            InitializeComponent();
        }

      
        private void Form1_Load(object sender, EventArgs e)
        {
            #region Setting Image
            //FarPoint.Win.Spread.CellType.ImageCellType imgct = new FarPoint.Win.Spread.CellType.ImageCellType();
            //System.Drawing.Image image = (Image)Properties.Resources.TestImage;
            //imgct.Style = FarPoint.Win.RenderStyle.Stretch;
            //imgct.TransparencyColor = System.Drawing.Color.Black;
            //imgct.TransparencyTolerance = 20;

            //fpSpread1.Sheets[0].Columns[1].Width = 300;
            //fpSpread1.Sheets[0].Rows[1].Height = 300;
            //fpSpread1.Sheets[0].Cells[1, 1].CellType = imgct;
            //fpSpread1.Sheets[0].Cells[1, 1].Value = image;
            #endregion

            fpSpread1.Sheets.Clear();
     
            string xml_file = "../../BiconXML.xml";
            XmlDocument xml = new XmlDocument();
            xml.Load(xml_file);
            FpSpread fpSpreadToOpenFile = new FpSpread();
            fpSpreadToOpenFile.Open(xml_file);
            this.fpSpread1.Sheets.Add(fpSpreadToOpenFile.Sheets[0]);
            this.fpSpread1.Sheets[0].AddCustomFunction(new GetEstimation());
            this.fpSpread1.Sheets[0].AutoCalculation = false;
            this.fpSpread1.Sheets[0].AutoCalculation = true;
            this.fpSpread1.Sheets[0].LoadFormulas(true);
        }
    }
}
